Subject: bug#2167: TODO progress regression in org-mode in Emacs pretest

From: Michael Ekstrand <[email-masked]>
Date: Mon, 02 Feb 2009 12:31:34 -0600

I upgraded this morning from an Emacs CVS build from Jan 28 or 19 to the
pretest release, and noticed a regression or undocumented change with
respect to org-after-todo-statistics-hook.  I am using the org-mode
which is included in the pretest distribution.

I have a function based on the code in section 5.5 of the Org manual to
close projects when their subtasks are complete.  Now, if I have a
headline which does not have a subtask counter in it and toggle one of
its children to DONE, my org-after-todo-statistics-hook function gets
called with n-done and n-not-done values of 0.  The parent headline thus
has its TODO status changed.

I don't think it matters too much, as my code worked before, but my hook
function is `org-summary-todo' from the following.  The first case of
the cond is being activated.

(defun mde-org-entry-is-project-p ()
  "Query whether the current headline is a project, returning
non-`nil' if it is and `nil' otherwise."
  (member "PROJECT" (org-get-tags-at)))

;;; Taken from Org Mode manual chapter 5.5
(defun org-summary-todo (n-done n-not-done)
  "Switch entry to DONE when all subentries are done, to TODO otherwise."
  (let ((org-log-done nil)
        (org-log-states nil))
    (cond
     ((and (or (org-entry-is-todo-p)
               (mde-org-entry-is-project-p))
           (= n-not-done 0))
      (org-todo
       (if (mde-org-entry-is-project-p)
           "FINISHED"
         "DONE")))
     ;; Entry is a project that is marked done
     ((and (mde-org-entry-is-project-p)
           (not (org-entry-is-todo-p))
           (org-get-todo-state)
           (> n-not-done 0))
      (org-todo 'none))
     ;; Entry is a task
     ((and (not (mde-org-entry-is-project-p))
           (not (org-entry-is-todo-p))
           (org-get-todo-state)
           (> n-not-done 0))
      (org-todo (org-get-todo-sequence-head))))))

There is a small chance that the problem was actually introduced a bit
earlier, perhaps since my Jan 20 build, but I think I would have noticed
it after at least the Jan 28 build.

I have CC'd bug-gnu-emacs to get this in as a bug report there as well.

- Michael

-- 
mouse, n: A device for pointing at the xterm in which you want to type.
Confused by the strange files?  I cryptographically sign my messages.
For more information see <http://www.elehack.net/resources/gpg>.